#!/bin/bash
#------------------------------------------------------------------------------
# Copyright (c) 2021 Olaf Jaehrling <eisfair(at)ojaehrling.(dot)de>
#
# Creation: 05.05.2021 by Olaf Jaehrling
# Last Update: 23.12.2021 by Olaf Jaehrling
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#------------------------------------------------------------------------------

_bfb-db() 
{
    local cur prev opts base
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"

    opts="init add del delproactive dellong show print display"
    

    ### erweiterte Vervollstaendigung ###
    case "${prev}" in
	print)
	    local action="atma block free proaktiv"
	    COMPREPLY=( $(compgen -W "${action}" -- ${cur}) )
            return 0
            ;;
        display)
	    local action1="anzahl anzahllong" 
	    COMPREPLY=( $(compgen -W "${action1}" -- ${cur}) )
            return 0
            ;;
        add)
            opts="[IP] block atma free"
         ;;
        del)
            opts="[IP]"
         ;;
        delproactive|dellong)
           opts="[IP]" 
        ;;
        show)
            opts="[IP] anzahl"
         ;;
        *)
         ;;
    esac

    COMPREPLY=($(compgen -W "${opts}" -- ${cur}))  
    return 0
}
complete -F _bfb-db bfb-db.sh
