#!/bin/bash
# Copyright (c) 2004-2023 Olaf Jaehrling <eisfair[at]ojaehrling[dot]de>
#
# Creation:     13.03.2005 OJae
# Last Update:  15.04.2023 OJae
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#----------------------------------------------------------------------------
#exec 2>/tmp/B_F_b_preinstall_trace-$$.log
#set -x

if [ -f /var/install/include/eislib ]
then
    . /var/install/include/eislib
fi
echo "running preinstall ..."
package='brute_force_blocking'

if [ -f /etc/eisfair-system ]
then
    installed_version=`/usr/bin/eisman check brute_force_blocking 2.1.4`
    if [ "$installed_version" = "new" ]
    then 
        mecho --info "using old initscript to stop bfb"
        if [ -f /etc/init.d/brute_force_blocking ]
        then
            BFBSTOP='/etc/init.d/brute_force_blocking stop'
        else
            BFBSTOP='service stop brute_force_blocking'
        fi
    else
        BFBSTOP='service stop brute_force_blocking'
    fi
else
     BFBSTOP='service brute_force_blocking stop'
fi
if [ -f /etc/eisfair-system ]
then
    if [ -f /etc/config.d/brute_force_blocking ]
    then
        cp /etc/config.d/brute_force_blocking /tmp/bfb-config
        . /etc/config.d/brute_force_blocking
    fi
else
    if [ -f /etc/default/brute_force_blocking ]
    then
        cp /etc/default/brute_force_blocking /tmp/bfb-config
        . /etc/default/brute_force_blocking
    fi
fi
if [ "$START_BRUTE_FORCE_BLOCKING" = "yes" ]
then
    if [ -f /usr/local/brute_force_blocking/configfile ]
    then
        . /usr/local/brute_force_blocking/configfile
    fi
    if [ -f $bfbhome/bfb.db ]
    then
        cp $bfbhome/bfb.db /tmp/BFB_RFD-db
    fi
    if  [ -d /usr/local/brute_force_blocking/ ]
    then
        if [ -f /etc/eisfair-system ]
        then
            grep FREE /etc/config.d/brute_force_blocking >/usr/local/brute_force_blocking/brute_force_blocking_freeoldstat
        else
            grep FREE /etc/default/brute_force_blocking >/usr/local/brute_force_blocking/brute_force_blocking_freeoldstat
        fi
    fi
    echo "stoppe nun BFB"
    if [ -f /run/brute_force_blocking.pid ]
    then
        touch /tmp/bfbwasrunning
        bash $BFBSTOP
        sleep 5
        PID=`ps -ef | grep "/brute_force_blocking/brute_force_blocking" | grep -v grep | awk '{print $2}'`
        if [ "$PID" != "" ]
        then
            #echo "kille $PID"
            kill -9 $PID
        fi
    fi
fi
export PATH="/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/bin:/sbin"

if [ -f /usr/local/brute_force_blocking/freeoldstat ]
then
    cp /usr/local/brute_force_blocking/freeoldstat /tmp/brute_force_blocking_freeoldstat
fi
if [ -f /usr/local/brute_force_blocking/brute_force_blocking_oldstat ]
then
    cp /usr/local/brute_force_blocking/brute_force_blocking_oldstat /tmp/brute_force_blocking_oldstat
fi

## Fehler in Version 2.1.0 und 2.1.1 beheben
if [ -f /etc/eisfair-system ]
then
    installed_version=`/usr/bin/eisman check brute_force_blocking 2.1.0`
    if [ "$installed_version" = "installed" ]
    then
        cp /etc/config.d/brute_force_blocking /tmp/bfbconfig
    fi
    installed_version=`/usr/bin/eisman check brute_force_blocking 2.1.1`
    if [ "$installed_version" = "installed" ]
    then
        if [ -f /etc/config.d/brute_force_blocking ]
        then
            cp /etc/config.d/brute_force_blocking /tmp/bfbconfig
        fi
    fi
else
    if [ -f /etc/default/brute_force_blocking ]
    then
        cp /etc/default/brute_force_blocking /tmp/bfbconfig
    fi
fi
if [ -s /usr/local/brute_force_blocking/excludelist-cust.list ]
then
    cp /usr/local/brute_force_blocking/excludelist-cust.list /tmp/
fi
exit 0
