#!/bin/bash
#----------------------------------------------------------------------------
# Copyright (c) 2004-2023 Olaf Jaehrling <eisfair@ojaehrling.de>
#
# Creation:     13.03.2005 OJae
# Last Update:  15.04.2023 OJae
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#----------------------------------------------------------------------------

if [ -f /var/install/include/eislib ]
then
    . /var/install/include/eislib
fi

if [ "$1" = "" ]
then
    echo "Enter the ip address you want to unblock"
    read ip >/dev/null
else
    ip=$1
fi
if [ "$2" = "dellong" ]
then
    ARGU=dellong
fi


if [ -f /etc/config.d/brute_force_blocking ]
then
    . /etc/config.d/brute_force_blocking
fi
if [ -f /etc/default/brute_force_blocking ]
then
    . /etc/default/brute_force_blocking
fi
if [ -f /usr/local/brute_force_blocking/configfile ]
then
    . /usr/local/brute_force_blocking/configfile
fi
        if [ "$BFB_BLOCK_REMOTE_SERVER" = "yes" ]
        then
            if [ "$BFB_USE_REMOTE_IPTABLES_NFTABLES" = "nftables" ]
            then
                (
                echo '#!/bin/bash'
                echo 'for handle in `$NFT -a list chain filter BFBBLOCK | grep -E "$ip" | awk -F"handle" {'"'print \$2'"'}`'
                echo 'do'
                echo '    $NFT delete rule filter BFBBLOCK handle $handle'
                echo 'done'
                echo 'for handle in `$NFT -a list chain filter BFBATMA | grep -E "$ip" | awk -F"handle" {'"'print \$2'" '}`'
                echo 'do'
                echo '    $NFT delete rule filter BFBATMA handle $handle'
                echo 'done'
                echo 'exit'
                )>/usr/local/brute_force_blocking/single_deblock
            else
                (
                echo '#!/bin/bash'
                echo "if [ -f /sbin/iptables ]"
                echo "then"
                echo '    IPTABLES="/sbin/iptables -w"'
                echo "else"
                echo '    IPTABLES="`which iptables` -w"'
                echo "fi"
                echo '$IPTABLES -D '$BFB_BLOCK_REMOTE_FORWARD_CHAIN' -s '$ip '-j '$type '>/dev/null 2>&1'
                echo '$IPTABLES -D BFBATMA -s '$ip '-j '$type '>/dev/null 2>&1'
                echo '$IPTABLES -D BFBBLOCK -s '$ip '-j '$type '>/dev/null 2>&1'
                if [ "$messages" = "yes" ]
                then
                    if [ "$extmessages" = "yes" ]
                    then
                        echo '$IPTABLES -D '$BFB_BLOCK_REMOTE_FORWARD_CHAIN' -s '$ip '-j '$tablelog_normal '>/dev/null 2>&1'
                        echo '$IPTABLES -D BFBATMA -s '$ip '-j '$tablelog_tw_normal '>/dev/null 2>&1'
                        echo '$IPTABLES -D BFBBLOCK -s '$ip '-j '$tablelog_normal '>/dev/null 2>&1'
                    else
                        echo '$IPTABLES -D '$BFB_BLOCK_REMOTE_FORWARD_CHAIN' -s '$ip '-j '$tablelog_brief '>/dev/null 2>&1'
                        echo '$IPTABLES -D BFBATMA -s '$ip '-j '$tablelog_tw_brief '>/dev/null 2>&1'
                        echo '$IPTABLES -D BFBBLOCK -s '$ip '-j '$tablelog_brief '>/dev/null 2>&1'
                    fi
                fi
                echo 'exit'
                )>/usr/local/brute_force_blocking/single_deblock
            fi
            _plink single
        else
            if [ "$BFB_USE_IPTABLES_NFTABLES" = "nftables" ]
            then
                if [ "$BFB_MAX_BLOCKING_TIME" = "yes" ]
                then
                    /usr/local/brute_force_blocking/zeitfreigabe $ip $ARGU
                else
                    for handle in `$NFT -a list chain filter BFBBLOCK | grep -w "$ip" | awk -F"handle" {'print $2'}`
                    do
                        $NFT delete rule filter BFBBLOCK handle $handle
                    done
                    if [ "$BFB_BLOCK_USE_IPV6" = "yes" ]
                    then
                        for handle in `$NFT -a list chain ip6 filter BFBBLOCK | grep -w "$ip" | awk -F"handle" {'print $2'}`
                        do
                            $NFT delete rule ip6 filter BFBBLOCK handle $handle
                        done
                    fi
                    for handle in `$NFT -a list chain filter BFBATMA | grep -w "$ip" | awk -F"handle" {'print $2'}`
                    do
                        $NFT delete rule filter BFBATMA handle $handle
                    done
                    if [ "$BFB_BLOCK_USE_IPV6" = "yes" ]
                    then
                        for handle in `$NFT -a list chain ip6 filter BFBATMA | grep -w "$ip" | awk -F"handle" {'print $2'}`
                        do
                            $NFT delete rule ip6 filter BFBATMA handle $handle
                        done
                    fi

                fi
                if [ "$BFB_BLOCK_PROACTIVE_FROM_DATABASE" = "yes" ]
                then
                    if $NFT list set ip filter BFBLONG |grep -w "${ip}" >/dev/null
                    then
                        $NFT delete element ip filter BFBLONG "{ $ip }"
                    fi
                    if [ "$BFB_BLOCK_USE_IPV6" = "yes" ]
                    then
                        if $NFT list set ip6 filter BFBLONG |grep -w "${ip}" >/dev/null
                        then
                            $NFT delete element ip6 filter BFBLONG "{ $ip }"
                        fi
                    fi
                    if [ "$ARGU" = "" ]
                    then
                        $bfbhome/bfb-db.sh dellong "${ip}" 2>&1 >/dev/null
                    fi
                fi
           else
                IPTABLES="`which iptables 2>/dev/null` -w"
                if [ "$BFB_MAX_BLOCKING_TIME" = "yes" ]
                then
                    /usr/local/brute_force_blocking/zeitfreigabe $ip $ARGU
                else
                    if ! grep -q "[a-zA-Z]" <<< $ip
                    then
                        $IPTABLES -D BFBBLOCK -s $ip -j $type 2>/dev/null 2>&1
                        if $IPTABLES -nL BFBATMA | grep -qF $ip
                        then
                            $IPTABLES -D BFBATMA -s $ip -j $type 2>/dev/null 2>&1
                        fi
                        if [ "$messages" = "yes" ]
                        then
                            if [ "$extmessages" = "yes" ]
                            then
                                $IPTABLES -D BFBBLOCK 2>/dev/null -s $ip -j $tablelog_normal >/dev/null 2>&1
                                if $IPTABLES -nL BFBATMA | grep -qF $ip
                                then
                                    $IPTABLES -D BFBATMA 2>/dev/null -s $ip -j $tablelog_tw_normal >/dev/null 2>&1
                                fi
                            else
                                $IPTABLES -D BFBBLOCK 2>/dev/null -s $ip -j $tablelog_brief >/dev/null 2>&1
                                if $IPTABLES -nL BFBATMA | grep -qF $ip
                                then
                                    $IPTABLES -D BFBATMA 2>/dev/null -s $ip -j $tablelog_tw_brief >/dev/null 2>&1
                                fi
                            fi
                        fi
                    fi
                fi
                if [ "$BFB_BLOCK_PROACTIVE_FROM_DATABASE" = "yes" ]
                then
                    if ! grep -q "[a-zA-Z]" <<< $ip
                    then
                        if ipset list BFBLONG | grep -w "${ip}" >/dev/null
                        then
                            ipset del BFBLONG "${ip}"
                        fi
                    fi
                    if [ "$ARGU" = "" ]
                    then
                        $bfbhome/bfb-db.sh dellong $ip 2&1 >/dev/null
                    fi
                fi
                if [ "$BFB_BLOCK_USE_IPV6" = "yes" ]
                then
                    IP6TABLES="`which ip6tables 2>/dev/null` -w"
                    if [ "$BFB_MAX_BLOCKING_TIME" = "yes" ]
                    then
                        /usr/local/brute_force_blocking/zeitfreigabe $ip $ARGU
                    else
                        if grep -q "[a-zA-Z]" <<< $ip
                        then
                            $IP6TABLES -D BFBBLOCK 2>/dev/null -s $ip -j $type >/dev/null 2>&1
                            $IP6TABLES -D BFBATMA 2>/dev/null -s $ip -j $type >/dev/null 2>&1
                            if [ "$messages" = "yes" ]
                            then
                                if [ "$extmessages" = "yes" ]
                                then
                                    $IP6TABLES -D BFBBLOCK 2>/dev/null -s $ip -j $tablelog_normal >/dev/null 2>&1
                                    $IP6TABLES -D BFBATMA 2>/dev/null -s $ip -j $tablelog_tw_normal >/dev/null 2>&1
                                else
                                    $IP6TABLES -D BFBBLOCK 2>/dev/null -s $ip -j $tablelog_brief >/dev/null 2>&1
                                    $IP6TABLES -D BFBATMA 2>/dev/null -s $ip -j $tablelog_tw_brief >/dev/null 2>&1
                                fi
                            fi
                        fi
                    fi
                    if [ "$BFB_BLOCK_PROACTIVE_FROM_DATABASE" = "yes" ]
                    then
                        if grep -q "[a-zA-Z]" <<< $ip
                        then
                            if ipset list BFBLONG6 | grep -w "${ip}" >/dev/null
                            then
                                ipset del BFBLONG6 "${ip}"
                            fi
                        fi
                        if [ "$ARGU" = "" ]
                        then
                            $bfbhome/bfb-db.sh dellong $ip 2&1 >/dev/null
                        fi
                    fi
                fi
            fi
        fi
        echo
        $bfbhome/bfb-db.sh delete $ip
        if [ "$DUP" != "bfbdb" ]
        then
            $bfbhome/bfb-db.sh delproactive $ip initd
        fi
        echo $ip "wurde freigegeben."

anykey
exit 0
