#!/bin/bash
#------------------------------------------------------------------------------
# Copyright (c) 2010-2023 Olaf Jaehrling <eisfair(at)ojaehrling.(dot)de>
#
# Creation: 07.12.2010 by Olaf Jaehrling
# Last Update: 15.04.2023 by Olaf Jaehrling
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#------------------------------------------------------------------------------

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
if [ -f /etc/config.d/brute_force_blocking ]
then
    . /etc/config.d/brute_force_blocking
fi
if [ -f /etc/default/brute_force_blocking ]
then
    . /etc/default/brute_force_blocking
fi

if [ -f /var/install/include/eislib ]
then
    . /var/install/include/eislib
fi

if [ -f /usr/local/brute_force_blocking/configfile ]
then
    . /usr/local/brute_force_blocking/configfile
fi

### wgetversion
wgetversion=`wget -V | head -1 | awk '{print $3}'`
if [ "$wgetversion" = "1.9.1" ]
then
    wgetoption='-q -O'
else
    wgetoption='--no-check-certificate -q -O'
fi


url='http://ojaehrling.de/eis/'
if [ -f /var/install/packages/brute_force_blocking ]
then
    version=`grep "<version>" /var/install/packages/brute_force_blocking | sed 's#</*version>##g; s/\.//g'`
    versionori=`grep "<version>" /var/install/packages/brute_force_blocking | sed 's#</*version>##g'`
    wget $wgetoption $bfbhome/brute_force_blocking.tar.bz2.check $url/brute_force_blocking.tar.bz2.info
    versionneu=`grep "<version>" $bfbhome/brute_force_blocking.tar.bz2.check | sed 's#</*version>##g; s/\.//g'`
    version2ori=`grep "<version>" $bfbhome/brute_force_blocking.tar.bz2.check | sed 's#</*version>##g'`
    version2=`echo $versionneu | awk -F"svn" '{print $1}'`
    versionsvn=`echo $version | egrep -o "s\v\n"`
    versionfirst=`echo $version |cut -c1`
    versionsec=`echo $versionneu |cut -c1`
    if [ "$versionneu" = "" ]
    then
        ## wahrscheinlich ist der webserver nicht erreichbar
        exit 0
    fi
    if [ "$versionsvn" = "svn" ]
    then
        ### es ist eine svn-version istalliert. Also keine Meldung
        version=`echo $version | awk -F"svn" '{print $1}'`
    fi
    if [ "$version" -gt "$version2" ]
    then
        if [ "$versionfirst" = "$versionsec" ]
            then
            ### es ist eine hoehere Version installiert, als auf dem Server.
            ### Also vermutlich eine Testversion
            exit 0
        fi
    fi
    if [ "$version" = "$version2" ]
    then
        if [ "$1" = "cron" ]
        then
            rm -f $bfbhome/brute_force_blocking.tar.bz2.check
            exit 0
        else
            #echo version=$version
            #echo version2=$version2
            #echo version_installiert=$versionori
            echo "your Version is up to date."
            echo "no update needed"
            rm -f $bfbhome/brute_force_blocking.tar.bz2.check
            anykey
        fi
    else
        wget $wgetoption /tmp/bfbchanges $url/bfbchanges
        if [ "$1" = "cron" ]
        then
            (
            echo "Subject: neue Brute_Force_Blocking-Version verfuegbar"
            echo "To: "$updatetoaddress 
            echo "From: "$updatefromaddress
            echo "Es ist eine neue Version verfuegbar"
            echo "Version auf Server: "$version2ori
            echo "installierte Version: "$versionori
            echo ""
            echo "folgende Aenderungen sind eingeflossen:"
            echo ""
            cat /tmp/bfbchanges
            echo ""
            echo "Du kannst die neue Version via pack-eis-search oder"
            echo "unter https://ojaehrling.de/eis/index.txt"
            echo "fuer pack-eis-search muss o.g. URL im setup eingetragen sein."
            echo "installieren."
            ) | sendmail -f $updatefromaddress $updatetoaddress 
        else
            echo "Es ist eine neue Version verfuegbar"
            echo "Version auf Server: "$version2ori
            echo "installierte Version: "$versionori
            echo ""
            echo "folgende Aenderungen sind eingeflossen:"
            echo ""
            cat /tmp/bfbchanges
            anykey
        fi
        rm -f /tmp/bfbchanges
    fi
fi

