#!/bin/bash
#----------------------------------------------------------------------------
# Copyright (c) 2005-2023 Olaf Jaehrling  eisfair(at)ojaehrling(dot)de
#
# Creation:     13.03.2005  by OJae
# Last Update:  07.08.2023  by OJae
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#----------------------------------------------------------------------------

if [ -f /etc/config.d/brute_force_blocking ]
then
    . /etc/config.d/brute_force_blocking
fi
if [ -f /etc/default/brute_force_blocking ]
then
    . /etc/default/brute_force_blocking
fi
if [ -f /usr/local/brute_force_blocking/configfile ]
then
    . /usr/local/brute_force_blocking/configfile
fi

if [ "$BFB_FREE_DYNDNS_DOMAIN" = "yes" ]
then
    if [ ! -d $bfbhome ]
    then
        exit 0
    fi
    NEW=$1
    idxd=1
    while [ "$idxd" -le "$BFB_FREE_DYNDNS_DOMAIN_N" ]
    do
        eval IP1='$BFB_FREE_DYNDNS_DOMAIN_'$idxd
        IP=`$DIG +short $IP1`
        IP6=`$DIG AAAA $IP1 |sed -n '/ANSWER SECTION/{n;p;}' |egrep -o '([a-f0-9:]+:+)+[a-f0-9]+'` 
        IP_OLD=`$bfbhome/bfb-db.sh show DD_$idxd reason`
        IP6_OLD=`$bfbhome/bfb-db.sh show DD6_$idxd reason`
        IPCHECK="DD_$idxd|$IP_OLD"
        IP6CHECK="DD6_$idxd|$IP6_OLD"


        if [ "$IP" != "" ]
        then
            if [ "$NEW" = "new" ]
            then
                $bfbhome/bfb-db.sh add $IP DD_$idxd
            else
                if [ "$IP_OLD" != "$IP" ]
                then
                    if [[ `$bfbhome/bfb-db.sh show DD_$idxd reasonip` = "$IPCHEK" ]]
                    then
                        $bfbhome/bfb-db.sh del $IP_OLD
                        $bfbhome/bfb-db.sh add $IP DD_$idxd
                    else
                        $bfbhome/bfb-db.sh add $IP DD_$idxd
                    fi
                fi
            fi
        fi
        if [ "$IP6" != "" ]
        then
            if [ "$NEW" = "new" ]
            then
                $bfbhome/bfb-db.sh add $IP DD6_$idxd
            else
                if [ "$IP6_OLD" != "$IP6" ]
                then
                    if [[ `$bfbhome/bfb-db.sh show DD6_$idxd reasonip` = "$IP6CHEK" ]]
                    then
                        $bfbhome/bfb-db.sh del $IP6_OLD
                        $bfbhome/bfb-db.sh add $IP6 DD6_$idxd
                    else
                        $bfbhome/bfb-db.sh add $IP6 DD6_$idxd
                    fi

                fi
            fi
        fi    

        idxd=`/usr/bin/expr $idxd + 1`
    done
fi

